function [wj_h, Pj_h, Ej_h, Cj_h]=DEK_WELFARE2_N1(wi_h3D, N , S, mu, Yi3D, Dj3D, Dj_h3D, betajs3D, consjs3D, sigma_s3D, tijs3D, tijs_p3D, tauijs_h3D, Lijs3D)
% report changes in relative wages wi_h, in real wages (term with lambda_jj,s),changes in k_j , and changes in welfare.

wj_h=wi_h3D(:,1,1);
wj_h3D=permute(wi_h3D,[2 1 3]);
Yj3D=permute(Yi3D,[2 1 3]);

% lambda_hat
phiijs_h3D=tauijs_h3D.*(1+tijs_p3D)./(1+tijs3D);    % changes in tariffs
AUX0=((phiijs_h3D.*wi_h3D).^(1-sigma_s3D));
AUX1=Lijs3D.*AUX0;
AUX2=repmat(sum(AUX1,1),[N 1 1]);
AUX3=AUX1./AUX2;    % lambda^ * lambda
Lijs_h3D=AUX0./AUX2;    % lambda^

% kappa_hat
AUX4=tijs3D.*Lijs3D.*betajs3D./(1+tijs3D);
AUX5=1-repmat(sum(sum(AUX4,3),1),[N 1 S]);  % kappa^(-1)
AUX6=tijs_p3D.*AUX3.*betajs3D./(1+tijs_p3D);
AUX7=1-repmat(sum(sum(AUX6,3),1),[N 1 S]);  % (kappa^ * kappa)^(-1)
kj_h3D=AUX5./AUX7;  %   kappa
kj_h_term3D=kj_h3D.*(wj_h3D.*Yj3D+Dj_h3D.*Dj3D.*(wj_h3D.^mu))./((Yj3D+Dj3D));
Ej_h=(kj_h_term3D(1,:,1))';

%Pj_hat
idx=find(eye(N));
Lijs_h2D=reshape(Lijs_h3D,N*N,S);
Ljjs_h2D=Lijs_h2D(idx,:);
Ljjs_h3D=permute(repmat(Ljjs_h2D,[1 1 N]),[3 1 2]);
AUX7=consjs3D./(1-sigma_s3D);
Pj_h2D=prod(Ljjs_h3D.^AUX7,3);
Pj_h=(Pj_h2D(1,:))'./wj_h;

% Cj_hat
Cj_h=Ej_h.*Pj_h;
end